osgUI::TabWidget Class Reference

`#include <TabWidget>`

Inheritance diagram for osgUI::TabWidget:

## Public Types

typedef std::vector< osg::ref_ptr< Tab > > | Tabs
Public Types inherited from osgUI::Widget
enum | FocusBehaviour { CLICK_TO_FOCUS , FOCUS_FOLLOWS_POINTER , EVENT_DRIVEN_FOCUS_DISABLED }
typedef std::vector< osgUtil::LineSegmentIntersector::Intersection > | Intersections
typedef std::map< int, osg::ref_ptr< osg::Node > > | GraphicsSubgraphMap
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| TabWidget ()
| TabWidget (const TabWidget &combobox, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgUI, TabWidget)
void | addTab (Tab *item)
void | setTab (unsigned int i, Tab *item)
Tab * | getTab (unsigned int i)
const Tab * | getTab (unsigned int i) const
void | clear ()
void | removeTab (unsigned int i)
unsigned int | getNumTabs ()
void | setTabs (const Tabs &items)
Tabs & | getTabs ()
const Tabs & | getTabs () const
void | setCurrentIndex (unsigned int i)
unsigned int | getCurrentIndex () const
virtual void | currrentIndexChanged (unsigned int i)
virtual void | currentIndexChangedImplementation (unsigned int i)
virtual bool | handleImplementation (osgGA::EventVisitor *ev, osgGA::Event *event)
virtual void | createGraphicsImplementation ()
virtual void | enterImplementation ()
virtual void | leaveImplementation ()
Public Member Functions inherited from osgUI::Widget
| Widget ()
| Widget (const Widget &widget, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgUI, Widget)
virtual void | traverse (osg::NodeVisitor &nv)
virtual void | traverseImplementation (osg::NodeVisitor &nv)
virtual bool | handle (osgGA::EventVisitor *ev, osgGA::Event *event)
virtual bool | computeIntersections (osgGA::EventVisitor *ev, osgGA::GUIEventAdapter *event, Intersections &intersections, osg::Node::NodeMask traversalMask=0xffffffff) const
virtual bool | computePositionInLocalCoordinates (osgGA::EventVisitor *ev, osgGA::GUIEventAdapter *event, osg::Vec3d &localPosition) const
virtual bool | computeExtentsPositionInLocalCoordinates (osgGA::EventVisitor *ev, osgGA::GUIEventAdapter *event, osg::Vec3d &localPosition, bool withinExtents=true) const
virtual void | dirty ()
void | setGraphicsSubgraph (int orderNum, osg::Node *node)
osg::Node * | getGraphicsSubgraph (int orderNum)
const osg::Node * | getGraphicsSubgraph (int orderNum) const
void | setGraphicsSubgraphMap (const GraphicsSubgraphMap &gsm)
GraphicsSubgraphMap & | getGraphicsSubgraphMap ()
const GraphicsSubgraphMap & | getGraphicsSubgraphMap () const
void | setWidgetStateSet (osg::StateSet *stateset)
osg::StateSet * | getWidgetStateSet ()
const osg::StateSet * | getWidgetStateSet () const
osg::StateSet * | getOrCreateWidgetStateSet ()
virtual void | createGraphics ()
virtual void | setExtents (const osg::BoundingBoxf &bb)
const osg::BoundingBoxf & | getExtents () const
void | setStyle (Style *style)
Style * | getStyle ()
const Style * | getStyle () const
void | setAlignmentSettings (AlignmentSettings *alignmentSettings)
AlignmentSettings * | getAlignmentSettings ()
const AlignmentSettings * | getAlignmentSettings () const
void | setFrameSettings (FrameSettings *textSettings)
FrameSettings * | getFrameSettings ()
const FrameSettings * | getFrameSettings () const
void | setTextSettings (TextSettings *textSettings)
TextSettings * | getTextSettings ()
const TextSettings * | getTextSettings () const
virtual void | setAutoFillBackground (bool enabled)
virtual bool | getAutoFillBackground () const
virtual void | setVisible (bool visible)
virtual bool | getVisible () const
virtual void | setEnabled (bool enabled)
virtual bool | getEnabled () const
void | setFocusBehaviour (FocusBehaviour behaviour)
FocusBehaviour | getFocusBehaviour () const
virtual void | updateFocus (osg::NodeVisitor &nv)
virtual void | setHasEventFocus (bool focus)
virtual bool | getHasEventFocus () const
bool | runCallbacks (const std::string &name, osg::Parameters &inputParameters, osg::Parameters &outputParameters)
bool | runCallbacks (const std::string &name)
virtual osg::BoundingSphere | computeBound () const
virtual void | enter ()
virtual void | leave ()
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~TabWidget ()
void | _activateWidgets ()
osg::Node * | _createTabFrame (const osg::BoundingBox &extents, osgUI::FrameSettings *fs, const osg::Vec4 &color)
osg::Node * | _createTabHeader (const osg::BoundingBox &extents, osgUI::FrameSettings *fs, const osg::Vec4 &color)
Protected Member Functions inherited from osgUI::Widget
virtual | ~Widget ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Tabs | _tabs
unsigned int | _currentIndex
osg::ref_ptr< osg::Switch > | _inactiveHeaderSwitch
osg::ref_ptr< osg::Switch > | _activeHeaderSwitch
osg::ref_ptr< osg::Switch > | _tabWidgetSwitch
Protected Attributes inherited from osgUI::Widget
FocusBehaviour | _focusBehaviour
bool | _hasEventFocus
bool | _graphicsInitialized
GraphicsSubgraphMap | _graphicsSubgraphMap
osg::ref_ptr< osg::StateSet > | _widgetStateSet
osg::BoundingBoxf | _extents
osg::ref_ptr< Style > | _style
osg::ref_ptr< AlignmentSettings > | _alignmentSettings
osg::ref_ptr< FrameSettings > | _frameSettings
osg::ref_ptr< TextSettings > | _textSettings
bool | _autoFillBackground
bool | _visible
bool | _enabled
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## Tabs

typedef std::vector< osg::ref_ptr<Tab> > osgUI::TabWidget::Tabs

## Constructor & Destructor Documentation

## TabWidget() [1/2]

osgUI::TabWidget::TabWidget | ( |  | ) |

Referenced by META_Node(), and TabWidget().

## TabWidget() [2/2]

osgUI::TabWidget::TabWidget | ( | const TabWidget & | combobox,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and TabWidget().

## ~TabWidget()

virtual osgUI::TabWidget::~TabWidget | ( |  | ) |

inline protected virtual

## Member Function Documentation

## _activateWidgets()

void osgUI::TabWidget::_activateWidgets | ( |  | ) |

protected

## _createTabFrame()

osg::Node * osgUI::TabWidget::_createTabFrame | ( | const osg::BoundingBox & | extents,
|  | osgUI::FrameSettings * | fs,
|  | const osg::Vec4 & | color )

protected

## _createTabHeader()

osg::Node * osgUI::TabWidget::_createTabHeader | ( | const osg::BoundingBox & | extents,
|  | osgUI::FrameSettings * | fs,
|  | const osg::Vec4 & | color )

protected

## addTab()

void osgUI::TabWidget::addTab | ( | Tab * | item | ) |

inline

References _tabs, and osgUI::Widget::dirty().

## clear()

void osgUI::TabWidget::clear | ( |  | ) |

inline

References _tabs, and osgUI::Widget::dirty().

## createGraphicsImplementation()

virtual void osgUI::TabWidget::createGraphicsImplementation | ( |  | ) |

virtual

createGraphicsImplementation method that creates the subgraph that will render the widget and assigns it to the Widget via the Widet::setGraphicsSubgraph() method.

Reimplemented from osgUI::Widget.

## currentIndexChangedImplementation()

virtual void osgUI::TabWidget::currentIndexChangedImplementation | ( | unsigned int | i | ) |

virtual

## currrentIndexChanged()

virtual void osgUI::TabWidget::currrentIndexChanged | ( | unsigned int | i | ) |

virtual

## enterImplementation()

virtual void osgUI::TabWidget::enterImplementation | ( |  | ) |

virtual

Reimplemented from osgUI::Widget.

## getCurrentIndex()

unsigned int osgUI::TabWidget::getCurrentIndex | ( |  | ) | const

inline

References _currentIndex.

## getNumTabs()

unsigned int osgUI::TabWidget::getNumTabs | ( |  | ) |

inline

References _tabs.

## getTab() [1/2]

Tab * osgUI::TabWidget::getTab | ( | unsigned int | i | ) |

inline

References _tabs.

## getTab() [2/2]

const Tab * osgUI::TabWidget::getTab | ( | unsigned int | i | ) | const

inline

References _tabs.

## getTabs() [1/2]

Tabs & osgUI::TabWidget::getTabs | ( |  | ) |

inline

References _tabs.

## getTabs() [2/2]

const Tabs & osgUI::TabWidget::getTabs | ( |  | ) | const

inline

References _tabs.

## handleImplementation()

virtual bool osgUI::TabWidget::handleImplementation | ( | osgGA::EventVisitor * | ev,
|  | osgGA::Event * | event )

virtual

Reimplemented from osgUI::Widget.

## leaveImplementation()

virtual void osgUI::TabWidget::leaveImplementation | ( |  | ) |

virtual

Reimplemented from osgUI::Widget.

## META_Node()

osgUI::TabWidget::META_Node | ( | osgUI | ,
|  | TabWidget | )

References TabWidget().

## removeTab()

void osgUI::TabWidget::removeTab | ( | unsigned int | i | ) |

inline

References _tabs, and osgUI::Widget::dirty().

## setCurrentIndex()

void osgUI::TabWidget::setCurrentIndex | ( | unsigned int | i | ) |

## setTab()

void osgUI::TabWidget::setTab | ( | unsigned int | i,
|  | Tab * | item )

inline

References _tabs, and osgUI::Widget::dirty().

## setTabs()

void osgUI::TabWidget::setTabs | ( | const Tabs & | items | ) |

inline

References _tabs.

## Member Data Documentation

## _activeHeaderSwitch

osg::ref_ptr<osg::Switch> osgUI::TabWidget::_activeHeaderSwitch

protected

## _currentIndex

unsigned int osgUI::TabWidget::_currentIndex

protected

Referenced by getCurrentIndex().

## _inactiveHeaderSwitch

osg::ref_ptr<osg::Switch> osgUI::TabWidget::_inactiveHeaderSwitch

protected

## _tabs

Tabs osgUI::TabWidget::_tabs

protected

Referenced by addTab(), clear(), getNumTabs(), getTab(), getTab(), getTabs(), getTabs(), removeTab(), setTab(), and setTabs().

## _tabWidgetSwitch

osg::ref_ptr<osg::Switch> osgUI::TabWidget::_tabWidgetSwitch

protected

The documentation for this class was generated from the following file:

- TabWidget